/**
 *
 * Copyright (c) 2006-2015, Speedment, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); You may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.speedment.core.config.model.aspects;

/**
 *
 * @author pemi
 */
public interface Ordinable extends Node {

    final int ORDINAL_FIRST = 1, UNSET = -1;

    int getOrdinalPosition();

    void setOrdinalPosition(int ordinalPosition);

    @Override
    default boolean isOrdinable() {
        return true;
    }

    default int compareToHelper(Ordinable that) {
        return Integer.compare(
                this.getOrdinalPosition(),
                that.getOrdinalPosition()
        );
    }
}
